/*
 * $Log:   
 */

/************************************************************************/
/*                                                                      */
/*              FAT-FTL Lite Software Development Kit                   */
/*              Copyright (C) M-Systems Ltd. 1995-2002                  */
/*                                                                      */
/************************************************************************/

/* flcustom.h for linux driver */

#include "flsystem.h"
#include "stdcomp.h"

unsigned char flUse8Bit;
unsigned char flUseNFTLCache;
unsigned char flUseisRAM;

/*-----------------------------------------------------------------------*/
/*                 f l s e t E n v V a r                                 */
/*  Sets the value of all environment variables                          */
/*  Parameters : None                                                    */
/*-----------------------------------------------------------------------*/
void flSetEnvVar(void)
{
	flGetEnvVarFromParam(&flUseisRAM,&flUseNFTLCache,&flUse8Bit);
}

/*----------------------------------------------------------------------*/
/*                f l R e g i s t e r C o m p o n e n t s               */
/*                                                                      */
/* Register socket, MTD and Translation Layer components for usage      */
/*                                                                      */
/* This function is called by FLite once only, at initialization of the */
/* FLite system.                                                        */
/*                                                                      */
/* Parameters:                                                          */
/*      None                                                            */
/*                                                                      */
/*----------------------------------------------------------------------*/

FLStatus flRegisterComponents(void)
{
	/* Registering socket interface */
	flRegisterDOCPLUSSOC(flGetWinL(),flGetWinH());
	flRegisterDOCSOC(flGetWinL(),flGetWinH());

	/* Registering MTD's */
	flRegisterDOCPLUS();	/* Register DiskOnChip Millennium Plus MTD */
	flRegisterDOC2000();	/* Register DiskOnChip 2000, Alon based DiskOnChips and DiskOnChip Millennium MTD      */

	/* Registering translation layers */
	flRegisterINFTL();		/* Register inftl.c */
	flRegisterNFTL();		/* Register nftllite.c */

	return flOK;
}
